package com.example.rgb_seekbar_kotlin

import android.graphics.Color
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.view.View
import android.widget.TextView
import android.widget.SeekBar
import android.widget.Toast

class MainActivity : AppCompatActivity() {

    //declare at class level so available outside on onCreate
    var mycolor = intArrayOf(255, 0, 0)
    var tvColor: TextView? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        // loop over seekbars and add listener
        for (i in 0..2) {
            val myID = "sb_$i"

            val resID = resources.getIdentifier(myID, "id", packageName)
            val mySeekBar = findViewById<View>(resID) as SeekBar
            mySeekBar.setOnSeekBarChangeListener(myListener)
        }
        tvColor = findViewById<TextView>(R.id.tvColor)

    } //end onCreate

    var myListener: SeekBar.OnSeekBarChangeListener = object : SeekBar.OnSeekBarChangeListener {
        override fun onProgressChanged(seekBar: SeekBar, i: Int, b: Boolean) {
            // seekBar.id gets a number and not what you called id in the layout xml
            // that's a resource
            val sb_name = resources.getResourceEntryName(seekBar.id)
            // my resources looked like sb_0, sb_1, sb_2  -- sue split to parse on underscore delimiter
            val parts = sb_name.split("_".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()

            //update the RGB array based on the number part from above
            mycolor[Integer.parseInt(parts[parts.size - 1])] = i

            // determine TextView associated with SeekBar that changed and update it
            val tv_name = "tv_" + parts[parts.size - 1]
            val resId = resources.getIdentifier(tv_name, "id", packageName)
            val my_tv = findViewById(resId) as TextView
            my_tv.text = "" + i

            // change the color of the TextView displaying the color based on the RGB array
            tvColor?.setBackgroundColor(Color.argb(255, mycolor[0], mycolor[1], mycolor[2]))
        }

        override fun onStartTrackingTouch(seekBar: SeekBar) {}

        // toast out which seekbar used
        override fun onStopTrackingTouch(seekBar: SeekBar) {
            val sb_name = resources.getResourceEntryName(seekBar.id)
            Toast.makeText(getApplicationContext(), sb_name, Toast.LENGTH_LONG).show();
        }
    }  //end myListener

}  //end MainActivity class
